G_BEGIN_DECLS

typedef void (*rtcom_tp_cli_stream_engine_signal_callback_receiving) (RTComTpStreamEngine *proxy,
    const gchar *arg_channel_path,
    guint arg_stream_id,
    gboolean arg_state,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *rtcom_tp_cli_stream_engine_connect_to_receiving (RTComTpStreamEngine *proxy,
    rtcom_tp_cli_stream_engine_signal_callback_receiving callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*rtcom_tp_cli_stream_engine_callback_for_get_output_window) (RTComTpStreamEngine *proxy,
    guint out_window,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_stream_engine_call_get_output_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    rtcom_tp_cli_stream_engine_callback_for_get_output_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_stream_engine_run_get_output_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    const gchar *in_channel_path,
    guint in_stream_id,
    guint *out_window,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_stream_engine_callback_for_create_preview_window) (RTComTpStreamEngine *proxy,
    guint out_window,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_stream_engine_call_create_preview_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    rtcom_tp_cli_stream_engine_callback_for_create_preview_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_stream_engine_run_create_preview_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    guint *out_window,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_stream_engine_callback_for_get_preview_window) (RTComTpStreamEngine *proxy,
    guint out_window,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_stream_engine_call_get_preview_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    rtcom_tp_cli_stream_engine_callback_for_get_preview_window callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_stream_engine_run_get_preview_window (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    guint *out_window,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_stream_engine_callback_for_shutdown) (RTComTpStreamEngine *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_stream_engine_call_shutdown (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    rtcom_tp_cli_stream_engine_callback_for_shutdown callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_stream_engine_run_shutdown (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    GError **error,
    GMainLoop **loop);


typedef void (*rtcom_tp_cli_stream_engine_callback_for_attach_to_channel) (RTComTpStreamEngine *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *rtcom_tp_cli_stream_engine_call_attach_to_channel (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    rtcom_tp_cli_stream_engine_callback_for_attach_to_channel callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean rtcom_tp_cli_stream_engine_run_attach_to_channel (RTComTpStreamEngine *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
