#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * RTComTpSvcChannelInterfaceConference:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceConference RTComTpSvcChannelInterfaceConference;

/**
 * RTComTpSvcChannelInterfaceConferenceClass:
 *
 * The class of RTComTpSvcChannelInterfaceConference.
 */
typedef struct _RTComTpSvcChannelInterfaceConferenceClass RTComTpSvcChannelInterfaceConferenceClass;

GType rtcom_tp_svc_channel_interface_conference_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE \
  (rtcom_tp_svc_channel_interface_conference_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE, RTComTpSvcChannelInterfaceConference))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_CONFERENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE, RTComTpSvcChannelInterfaceConferenceClass))


typedef void (*rtcom_tp_svc_channel_interface_conference_add_member_channels_impl) (RTComTpSvcChannelInterfaceConference *self,
    const GPtrArray *in_Members,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_conference_implement_add_member_channels (RTComTpSvcChannelInterfaceConferenceClass *klass, rtcom_tp_svc_channel_interface_conference_add_member_channels_impl impl);
/**
 * rtcom_tp_svc_channel_interface_conference_return_from_add_member_channels:
 * @context: The D-Bus method invocation context
 * @out_Handles: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_conference_return_from_add_member_channels (DBusGMethodInvocation *context,
    const GPtrArray *out_Handles);
static inline void
rtcom_tp_svc_channel_interface_conference_return_from_add_member_channels (DBusGMethodInvocation *context,
    const GPtrArray *out_Handles)
{
  dbus_g_method_return (context,
      out_Handles);
}

typedef void (*rtcom_tp_svc_channel_interface_conference_get_member_channels_impl) (RTComTpSvcChannelInterfaceConference *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_conference_implement_get_member_channels (RTComTpSvcChannelInterfaceConferenceClass *klass, rtcom_tp_svc_channel_interface_conference_get_member_channels_impl impl);
/**
 * rtcom_tp_svc_channel_interface_conference_return_from_get_member_channels:
 * @context: The D-Bus method invocation context
 * @out_Channels: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_conference_return_from_get_member_channels (DBusGMethodInvocation *context,
    const GPtrArray *out_Channels);
static inline void
rtcom_tp_svc_channel_interface_conference_return_from_get_member_channels (DBusGMethodInvocation *context,
    const GPtrArray *out_Channels)
{
  dbus_g_method_return (context,
      out_Channels);
}

void rtcom_tp_svc_channel_interface_conference_emit_member_channel_added (gpointer instance,
    const gchar *arg_Channel,
    GHashTable *arg_Handles);
void rtcom_tp_svc_channel_interface_conference_emit_member_channel_removed (gpointer instance,
    const gchar *arg_Channel,
    guint arg_Actor,
    guint arg_Reason);

/**
 * RTComTpSvcChannelInterfaceConferenceMember:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceConferenceMember RTComTpSvcChannelInterfaceConferenceMember;

/**
 * RTComTpSvcChannelInterfaceConferenceMemberClass:
 *
 * The class of RTComTpSvcChannelInterfaceConferenceMember.
 */
typedef struct _RTComTpSvcChannelInterfaceConferenceMemberClass RTComTpSvcChannelInterfaceConferenceMemberClass;

GType rtcom_tp_svc_channel_interface_conference_member_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER \
  (rtcom_tp_svc_channel_interface_conference_member_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER, RTComTpSvcChannelInterfaceConferenceMember))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_CONFERENCE_MEMBER, RTComTpSvcChannelInterfaceConferenceMemberClass))


typedef void (*rtcom_tp_svc_channel_interface_conference_member_join_conference_impl) (RTComTpSvcChannelInterfaceConferenceMember *self,
    const gchar *in_ConferenceChannel,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_conference_member_implement_join_conference (RTComTpSvcChannelInterfaceConferenceMemberClass *klass, rtcom_tp_svc_channel_interface_conference_member_join_conference_impl impl);
/**
 * rtcom_tp_svc_channel_interface_conference_member_return_from_join_conference:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_conference_member_return_from_join_conference (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_conference_member_return_from_join_conference (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_channel_interface_conference_member_get_conference_impl) (RTComTpSvcChannelInterfaceConferenceMember *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_conference_member_implement_get_conference (RTComTpSvcChannelInterfaceConferenceMemberClass *klass, rtcom_tp_svc_channel_interface_conference_member_get_conference_impl impl);
/**
 * rtcom_tp_svc_channel_interface_conference_member_return_from_get_conference:
 * @context: The D-Bus method invocation context
 * @out_ConferenceChannel: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_conference_member_return_from_get_conference (DBusGMethodInvocation *context,
    const gchar *out_ConferenceChannel);
static inline void
rtcom_tp_svc_channel_interface_conference_member_return_from_get_conference (DBusGMethodInvocation *context,
    const gchar *out_ConferenceChannel)
{
  dbus_g_method_return (context,
      out_ConferenceChannel);
}

typedef void (*rtcom_tp_svc_channel_interface_conference_member_leave_conference_impl) (RTComTpSvcChannelInterfaceConferenceMember *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_conference_member_implement_leave_conference (RTComTpSvcChannelInterfaceConferenceMemberClass *klass, rtcom_tp_svc_channel_interface_conference_member_leave_conference_impl impl);
/**
 * rtcom_tp_svc_channel_interface_conference_member_return_from_leave_conference:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_conference_member_return_from_leave_conference (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_conference_member_return_from_leave_conference (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_channel_interface_conference_member_emit_joined_conference (gpointer instance,
    const gchar *arg_ConferenceChannel);
void rtcom_tp_svc_channel_interface_conference_member_emit_left_conference (gpointer instance);

/**
 * RTComTpSvcChannelInterfaceDialStrings:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceDialStrings RTComTpSvcChannelInterfaceDialStrings;

/**
 * RTComTpSvcChannelInterfaceDialStringsClass:
 *
 * The class of RTComTpSvcChannelInterfaceDialStrings.
 */
typedef struct _RTComTpSvcChannelInterfaceDialStringsClass RTComTpSvcChannelInterfaceDialStringsClass;

GType rtcom_tp_svc_channel_interface_dial_strings_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS \
  (rtcom_tp_svc_channel_interface_dial_strings_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS, RTComTpSvcChannelInterfaceDialStrings))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_DIAL_STRINGS, RTComTpSvcChannelInterfaceDialStringsClass))


typedef void (*rtcom_tp_svc_channel_interface_dial_strings_send_dial_string_impl) (RTComTpSvcChannelInterfaceDialStrings *self,
    guint in_Stream_ID,
    const gchar *in_Dial_String,
    guint in_Duration,
    guint in_Pause,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_dial_strings_implement_send_dial_string (RTComTpSvcChannelInterfaceDialStringsClass *klass, rtcom_tp_svc_channel_interface_dial_strings_send_dial_string_impl impl);
/**
 * rtcom_tp_svc_channel_interface_dial_strings_return_from_send_dial_string:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_dial_strings_return_from_send_dial_string (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_dial_strings_return_from_send_dial_string (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_channel_interface_dial_strings_cancel_dial_string_impl) (RTComTpSvcChannelInterfaceDialStrings *self,
    guint in_Stream_ID,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_dial_strings_implement_cancel_dial_string (RTComTpSvcChannelInterfaceDialStringsClass *klass, rtcom_tp_svc_channel_interface_dial_strings_cancel_dial_string_impl impl);
/**
 * rtcom_tp_svc_channel_interface_dial_strings_return_from_cancel_dial_string:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_dial_strings_return_from_cancel_dial_string (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_dial_strings_return_from_cancel_dial_string (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_channel_interface_dial_strings_get_current_dial_strings_impl) (RTComTpSvcChannelInterfaceDialStrings *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_dial_strings_implement_get_current_dial_strings (RTComTpSvcChannelInterfaceDialStringsClass *klass, rtcom_tp_svc_channel_interface_dial_strings_get_current_dial_strings_impl impl);
/**
 * rtcom_tp_svc_channel_interface_dial_strings_return_from_get_current_dial_strings:
 * @context: The D-Bus method invocation context
 * @out_Dial_Strings: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_dial_strings_return_from_get_current_dial_strings (DBusGMethodInvocation *context,
    GHashTable *out_Dial_Strings);
static inline void
rtcom_tp_svc_channel_interface_dial_strings_return_from_get_current_dial_strings (DBusGMethodInvocation *context,
    GHashTable *out_Dial_Strings)
{
  dbus_g_method_return (context,
      out_Dial_Strings);
}

void rtcom_tp_svc_channel_interface_dial_strings_emit_sending_dial_string (gpointer instance,
    guint arg_Stream_ID,
    const gchar *arg_Dial_String);
void rtcom_tp_svc_channel_interface_dial_strings_emit_stopped_dial_string (gpointer instance,
    guint arg_Stream_ID,
    gboolean arg_Sent);

/**
 * RTComTpSvcChannelInterfaceEmergency:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceEmergency RTComTpSvcChannelInterfaceEmergency;

/**
 * RTComTpSvcChannelInterfaceEmergencyClass:
 *
 * The class of RTComTpSvcChannelInterfaceEmergency.
 */
typedef struct _RTComTpSvcChannelInterfaceEmergencyClass RTComTpSvcChannelInterfaceEmergencyClass;

GType rtcom_tp_svc_channel_interface_emergency_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_EMERGENCY \
  (rtcom_tp_svc_channel_interface_emergency_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_EMERGENCY(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_EMERGENCY, RTComTpSvcChannelInterfaceEmergency))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_EMERGENCY(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_EMERGENCY))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_EMERGENCY_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_EMERGENCY, RTComTpSvcChannelInterfaceEmergencyClass))


typedef void (*rtcom_tp_svc_channel_interface_emergency_get_emergency_service_impl) (RTComTpSvcChannelInterfaceEmergency *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_emergency_implement_get_emergency_service (RTComTpSvcChannelInterfaceEmergencyClass *klass, rtcom_tp_svc_channel_interface_emergency_get_emergency_service_impl impl);
/**
 * rtcom_tp_svc_channel_interface_emergency_return_from_get_emergency_service:
 * @context: The D-Bus method invocation context
 * @out_service: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_emergency_return_from_get_emergency_service (DBusGMethodInvocation *context,
    const gchar *out_service);
static inline void
rtcom_tp_svc_channel_interface_emergency_return_from_get_emergency_service (DBusGMethodInvocation *context,
    const gchar *out_service)
{
  dbus_g_method_return (context,
      out_service);
}

void rtcom_tp_svc_channel_interface_emergency_emit_emergency_service_changed (gpointer instance,
    const gchar *arg_service);

/**
 * RTComTpSvcChannelInterfaceHold:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceHold RTComTpSvcChannelInterfaceHold;

/**
 * RTComTpSvcChannelInterfaceHoldClass:
 *
 * The class of RTComTpSvcChannelInterfaceHold.
 */
typedef struct _RTComTpSvcChannelInterfaceHoldClass RTComTpSvcChannelInterfaceHoldClass;

GType rtcom_tp_svc_channel_interface_hold_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_HOLD \
  (rtcom_tp_svc_channel_interface_hold_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_HOLD, RTComTpSvcChannelInterfaceHold))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_HOLD))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_HOLD, RTComTpSvcChannelInterfaceHoldClass))


typedef void (*rtcom_tp_svc_channel_interface_hold_get_hold_state_impl) (RTComTpSvcChannelInterfaceHold *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_hold_implement_get_hold_state (RTComTpSvcChannelInterfaceHoldClass *klass, rtcom_tp_svc_channel_interface_hold_get_hold_state_impl impl);
/**
 * rtcom_tp_svc_channel_interface_hold_return_from_get_hold_state:
 * @context: The D-Bus method invocation context
 * @out_HoldState: guint  (FIXME, generate documentation)
 * @out_Reason: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out_HoldState,
    guint out_Reason);
static inline void
rtcom_tp_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *context,
    guint out_HoldState,
    guint out_Reason)
{
  dbus_g_method_return (context,
      out_HoldState,
      out_Reason);
}

typedef void (*rtcom_tp_svc_channel_interface_hold_request_hold_impl) (RTComTpSvcChannelInterfaceHold *self,
    gboolean in_Hold,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_hold_implement_request_hold (RTComTpSvcChannelInterfaceHoldClass *klass, rtcom_tp_svc_channel_interface_hold_request_hold_impl impl);
/**
 * rtcom_tp_svc_channel_interface_hold_return_from_request_hold:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_channel_interface_hold_emit_hold_state_changed (gpointer instance,
    guint arg_HoldState,
    guint arg_Reason);

/**
 * RTComTpSvcChannelInterfaceMessages:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceMessages RTComTpSvcChannelInterfaceMessages;

/**
 * RTComTpSvcChannelInterfaceMessagesClass:
 *
 * The class of RTComTpSvcChannelInterfaceMessages.
 */
typedef struct _RTComTpSvcChannelInterfaceMessagesClass RTComTpSvcChannelInterfaceMessagesClass;

GType rtcom_tp_svc_channel_interface_messages_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MESSAGES \
  (rtcom_tp_svc_channel_interface_messages_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_MESSAGES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MESSAGES, RTComTpSvcChannelInterfaceMessages))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_MESSAGES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MESSAGES))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_MESSAGES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MESSAGES, RTComTpSvcChannelInterfaceMessagesClass))


typedef void (*rtcom_tp_svc_channel_interface_messages_send_message_impl) (RTComTpSvcChannelInterfaceMessages *self,
    const GPtrArray *in_Message,
    guint in_Flags,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_messages_implement_send_message (RTComTpSvcChannelInterfaceMessagesClass *klass, rtcom_tp_svc_channel_interface_messages_send_message_impl impl);
/**
 * rtcom_tp_svc_channel_interface_messages_return_from_send_message:
 * @context: The D-Bus method invocation context
 * @out_Token: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_messages_return_from_send_message (DBusGMethodInvocation *context,
    const gchar *out_Token);
static inline void
rtcom_tp_svc_channel_interface_messages_return_from_send_message (DBusGMethodInvocation *context,
    const gchar *out_Token)
{
  dbus_g_method_return (context,
      out_Token);
}

typedef void (*rtcom_tp_svc_channel_interface_messages_get_pending_message_content_impl) (RTComTpSvcChannelInterfaceMessages *self,
    guint in_Message_ID,
    const GArray *in_Parts,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_messages_implement_get_pending_message_content (RTComTpSvcChannelInterfaceMessagesClass *klass, rtcom_tp_svc_channel_interface_messages_get_pending_message_content_impl impl);
/**
 * rtcom_tp_svc_channel_interface_messages_return_from_get_pending_message_content:
 * @context: The D-Bus method invocation context
 * @out_Content: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_messages_return_from_get_pending_message_content (DBusGMethodInvocation *context,
    GHashTable *out_Content);
static inline void
rtcom_tp_svc_channel_interface_messages_return_from_get_pending_message_content (DBusGMethodInvocation *context,
    GHashTable *out_Content)
{
  dbus_g_method_return (context,
      out_Content);
}

void rtcom_tp_svc_channel_interface_messages_emit_message_sent (gpointer instance,
    const GPtrArray *arg_Content,
    guint arg_Flags,
    const gchar *arg_Message_Token);
void rtcom_tp_svc_channel_interface_messages_emit_pending_messages_removed (gpointer instance,
    const GArray *arg_Message_IDs);
void rtcom_tp_svc_channel_interface_messages_emit_message_received (gpointer instance,
    const GPtrArray *arg_Message);

/**
 * RTComTpSvcChannelInterfaceMute:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceMute RTComTpSvcChannelInterfaceMute;

/**
 * RTComTpSvcChannelInterfaceMuteClass:
 *
 * The class of RTComTpSvcChannelInterfaceMute.
 */
typedef struct _RTComTpSvcChannelInterfaceMuteClass RTComTpSvcChannelInterfaceMuteClass;

GType rtcom_tp_svc_channel_interface_mute_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MUTE \
  (rtcom_tp_svc_channel_interface_mute_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_MUTE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MUTE, RTComTpSvcChannelInterfaceMute))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_MUTE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MUTE))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_MUTE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_MUTE, RTComTpSvcChannelInterfaceMuteClass))


typedef void (*rtcom_tp_svc_channel_interface_mute_get_mute_state_impl) (RTComTpSvcChannelInterfaceMute *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_mute_implement_get_mute_state (RTComTpSvcChannelInterfaceMuteClass *klass, rtcom_tp_svc_channel_interface_mute_get_mute_state_impl impl);
/**
 * rtcom_tp_svc_channel_interface_mute_return_from_get_mute_state:
 * @context: The D-Bus method invocation context
 * @out_Muted: gboolean  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_mute_return_from_get_mute_state (DBusGMethodInvocation *context,
    gboolean out_Muted);
static inline void
rtcom_tp_svc_channel_interface_mute_return_from_get_mute_state (DBusGMethodInvocation *context,
    gboolean out_Muted)
{
  dbus_g_method_return (context,
      out_Muted);
}

typedef void (*rtcom_tp_svc_channel_interface_mute_request_mute_impl) (RTComTpSvcChannelInterfaceMute *self,
    gboolean in_Mute,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_mute_implement_request_mute (RTComTpSvcChannelInterfaceMuteClass *klass, rtcom_tp_svc_channel_interface_mute_request_mute_impl impl);
/**
 * rtcom_tp_svc_channel_interface_mute_return_from_request_mute:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_mute_return_from_request_mute (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_mute_return_from_request_mute (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_channel_interface_mute_emit_mute_state_changed (gpointer instance,
    gboolean arg_Muted);

/**
 * RTComTpSvcChannelInterfacePersistent:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfacePersistent RTComTpSvcChannelInterfacePersistent;

/**
 * RTComTpSvcChannelInterfacePersistentClass:
 *
 * The class of RTComTpSvcChannelInterfacePersistent.
 */
typedef struct _RTComTpSvcChannelInterfacePersistentClass RTComTpSvcChannelInterfacePersistentClass;

GType rtcom_tp_svc_channel_interface_persistent_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PERSISTENT \
  (rtcom_tp_svc_channel_interface_persistent_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_PERSISTENT(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PERSISTENT, RTComTpSvcChannelInterfacePersistent))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_PERSISTENT(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PERSISTENT))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_PERSISTENT_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PERSISTENT, RTComTpSvcChannelInterfacePersistentClass))



/**
 * RTComTpSvcChannelInterfacePrivacy:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfacePrivacy RTComTpSvcChannelInterfacePrivacy;

/**
 * RTComTpSvcChannelInterfacePrivacyClass:
 *
 * The class of RTComTpSvcChannelInterfacePrivacy.
 */
typedef struct _RTComTpSvcChannelInterfacePrivacyClass RTComTpSvcChannelInterfacePrivacyClass;

GType rtcom_tp_svc_channel_interface_privacy_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PRIVACY \
  (rtcom_tp_svc_channel_interface_privacy_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PRIVACY, RTComTpSvcChannelInterfacePrivacy))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PRIVACY))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_PRIVACY_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_PRIVACY, RTComTpSvcChannelInterfacePrivacyClass))


void rtcom_tp_svc_channel_interface_privacy_emit_privacy_services_changed (gpointer instance,
    const gchar **arg_services);

/**
 * RTComTpSvcChannelInterfaceSMS:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceSMS RTComTpSvcChannelInterfaceSMS;

/**
 * RTComTpSvcChannelInterfaceSMSClass:
 *
 * The class of RTComTpSvcChannelInterfaceSMS.
 */
typedef struct _RTComTpSvcChannelInterfaceSMSClass RTComTpSvcChannelInterfaceSMSClass;

GType rtcom_tp_svc_channel_interface_sms_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SMS \
  (rtcom_tp_svc_channel_interface_sms_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_SMS(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SMS, RTComTpSvcChannelInterfaceSMS))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_SMS(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SMS))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_SMS_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SMS, RTComTpSvcChannelInterfaceSMSClass))



/**
 * RTComTpSvcChannelInterfaceSkypeGroupChat:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceSkypeGroupChat RTComTpSvcChannelInterfaceSkypeGroupChat;

/**
 * RTComTpSvcChannelInterfaceSkypeGroupChatClass:
 *
 * The class of RTComTpSvcChannelInterfaceSkypeGroupChat.
 */
typedef struct _RTComTpSvcChannelInterfaceSkypeGroupChatClass RTComTpSvcChannelInterfaceSkypeGroupChatClass;

GType rtcom_tp_svc_channel_interface_skype_groupchat_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT \
  (rtcom_tp_svc_channel_interface_skype_groupchat_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT, RTComTpSvcChannelInterfaceSkypeGroupChat))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_SKYPE_GROUPCHAT, RTComTpSvcChannelInterfaceSkypeGroupChatClass))


typedef void (*rtcom_tp_svc_channel_interface_skype_groupchat_leave_impl) (RTComTpSvcChannelInterfaceSkypeGroupChat *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_interface_skype_groupchat_implement_leave (RTComTpSvcChannelInterfaceSkypeGroupChatClass *klass, rtcom_tp_svc_channel_interface_skype_groupchat_leave_impl impl);
/**
 * rtcom_tp_svc_channel_interface_skype_groupchat_return_from_leave:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_interface_skype_groupchat_return_from_leave (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_interface_skype_groupchat_return_from_leave (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_channel_interface_skype_groupchat_emit_topic_changed (gpointer instance,
    guint arg_handle,
    const gchar *arg_newtopic);

/**
 * RTComTpSvcChannelInterfaceVoicemailSkype:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelInterfaceVoicemailSkype RTComTpSvcChannelInterfaceVoicemailSkype;

/**
 * RTComTpSvcChannelInterfaceVoicemailSkypeClass:
 *
 * The class of RTComTpSvcChannelInterfaceVoicemailSkype.
 */
typedef struct _RTComTpSvcChannelInterfaceVoicemailSkypeClass RTComTpSvcChannelInterfaceVoicemailSkypeClass;

GType rtcom_tp_svc_channel_interface_voicemail_skype_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE \
  (rtcom_tp_svc_channel_interface_voicemail_skype_get_type ())
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE, RTComTpSvcChannelInterfaceVoicemailSkype))
#define RTCOM_IS_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE))
#define RTCOM_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_INTERFACE_VOICEMAIL_SKYPE, RTComTpSvcChannelInterfaceVoicemailSkypeClass))



/**
 * RTComTpSvcChannelTypeContactSearch:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelTypeContactSearch RTComTpSvcChannelTypeContactSearch;

/**
 * RTComTpSvcChannelTypeContactSearchClass:
 *
 * The class of RTComTpSvcChannelTypeContactSearch.
 */
typedef struct _RTComTpSvcChannelTypeContactSearchClass RTComTpSvcChannelTypeContactSearchClass;

GType rtcom_tp_svc_channel_type_contact_search_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH \
  (rtcom_tp_svc_channel_type_contact_search_get_type ())
#define RTCOM_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH, RTComTpSvcChannelTypeContactSearch))
#define RTCOM_IS_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH))
#define RTCOM_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH, RTComTpSvcChannelTypeContactSearchClass))


typedef void (*rtcom_tp_svc_channel_type_contact_search_search_impl) (RTComTpSvcChannelTypeContactSearch *self,
    GHashTable *in_Terms,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_type_contact_search_implement_search (RTComTpSvcChannelTypeContactSearchClass *klass, rtcom_tp_svc_channel_type_contact_search_search_impl impl);
/**
 * rtcom_tp_svc_channel_type_contact_search_return_from_search:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_type_contact_search_return_from_search (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_type_contact_search_return_from_search (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_channel_type_contact_search_more_impl) (RTComTpSvcChannelTypeContactSearch *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_type_contact_search_implement_more (RTComTpSvcChannelTypeContactSearchClass *klass, rtcom_tp_svc_channel_type_contact_search_more_impl impl);
/**
 * rtcom_tp_svc_channel_type_contact_search_return_from_more:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_type_contact_search_return_from_more (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_type_contact_search_return_from_more (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*rtcom_tp_svc_channel_type_contact_search_stop_impl) (RTComTpSvcChannelTypeContactSearch *self,
    DBusGMethodInvocation *context);
void rtcom_tp_svc_channel_type_contact_search_implement_stop (RTComTpSvcChannelTypeContactSearchClass *klass, rtcom_tp_svc_channel_type_contact_search_stop_impl impl);
/**
 * rtcom_tp_svc_channel_type_contact_search_return_from_stop:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void rtcom_tp_svc_channel_type_contact_search_return_from_stop (DBusGMethodInvocation *context);
static inline void
rtcom_tp_svc_channel_type_contact_search_return_from_stop (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void rtcom_tp_svc_channel_type_contact_search_emit_search_state_changed (gpointer instance,
    guint arg_State,
    const gchar *arg_Error,
    GHashTable *arg_Details);
void rtcom_tp_svc_channel_type_contact_search_emit_search_result_received (gpointer instance,
    guint arg_Contact,
    const GPtrArray *arg_Info);

/**
 * RTComTpSvcChannelTypeStreamedMediaFuture:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _RTComTpSvcChannelTypeStreamedMediaFuture RTComTpSvcChannelTypeStreamedMediaFuture;

/**
 * RTComTpSvcChannelTypeStreamedMediaFutureClass:
 *
 * The class of RTComTpSvcChannelTypeStreamedMediaFuture.
 */
typedef struct _RTComTpSvcChannelTypeStreamedMediaFutureClass RTComTpSvcChannelTypeStreamedMediaFutureClass;

GType rtcom_tp_svc_channel_type_streamed_media_future_get_type (void);
#define RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE \
  (rtcom_tp_svc_channel_type_streamed_media_future_get_type ())
#define RTCOM_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE, RTComTpSvcChannelTypeStreamedMediaFuture))
#define RTCOM_IS_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE))
#define RTCOM_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), RTCOM_TYPE_TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_FUTURE, RTComTpSvcChannelTypeStreamedMediaFutureClass))




G_END_DECLS
